// Compiled by ClojureScript 0.0-2138
goog.provide('lt.object');
goog.require('cljs.core');
goog.require('lt.util.dom');
goog.require('lt.util.js');
goog.require('crate.binding');
goog.require('lt.util.js');
goog.require('lt.util.dom');
goog.require('lt.util.cljs');
goog.require('crate.core');
goog.require('lt.util.dom');
goog.require('clojure.string');
goog.require('lt.util.cljs');
goog.require('clojure.set');
goog.require('clojure.string');
goog.require('crate.binding');
goog.require('clojure.set');
goog.require('crate.core');
/**
* Counter to guarantee unique object ids
*/
lt.object.obj_id = cljs.core.atom.call(null,0);
/**
* Map of object ids to objects created by object/create
*/
lt.object.instances = cljs.core.atom.call(null,cljs.core.sorted_map.call(null));
/**
* Map of behavior names to behaviors created by macros/behavior
*/
lt.object.behaviors = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of object template keys to template maps created by object/object*
*/
lt.object.object_defs = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to associated lists of behaviors
*/
lt.object.tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Map of tags to dissociated lists of behaviors e.g. :-behavior
*/
lt.object.negated_tags = cljs.core.atom.call(null,cljs.core.PersistentArrayMap.EMPTY);
/**
* Metadata of current behavior set during raise and raise-reduce
*/
lt.object._STAR_behavior_meta_STAR_ = null;
lt.object.add = (function add(obj){return cljs.core.swap_BANG_.call(null,lt.object.object_defs,cljs.core.assoc,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(obj),obj);
});
lt.object.add_behavior = (function add_behavior(beh){return cljs.core.swap_BANG_.call(null,lt.object.behaviors,cljs.core.assoc,new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh),beh);
});
/**
* Return id of given object
*/
lt.object.__GT_id = (function __GT_id(obj){if(crate.binding.deref_QMARK_.call(null,obj))
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
} else
{return new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);
}
});
lt.object.__GT_behavior_name = (function __GT_behavior_name(beh){if(cljs.core.coll_QMARK_.call(null,beh))
{return cljs.core.first.call(null,beh);
} else
{return beh;
}
});
lt.object.__GT_behavior = (function __GT_behavior(beh){return cljs.core.deref.call(null,lt.object.behaviors).call(null,lt.object.__GT_behavior_name.call(null,beh));
});
lt.object.__GT_triggers = (function __GT_triggers(behs){var result = cljs.core.atom.call(null,cljs.core.transient$.call(null,cljs.core.PersistentArrayMap.EMPTY));var seq__13651_13663 = cljs.core.seq.call(null,behs);var chunk__13656_13664 = null;var count__13657_13665 = 0;var i__13658_13666 = 0;while(true){
if((i__13658_13666 < count__13657_13665))
{var beh_13667 = cljs.core._nth.call(null,chunk__13656_13664,i__13658_13666);var seq__13659_13668 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_13667)));var chunk__13660_13669 = null;var count__13661_13670 = 0;var i__13662_13671 = 0;while(true){
if((i__13662_13671 < count__13661_13670))
{var t_13672 = cljs.core._nth.call(null,chunk__13660_13669,i__13662_13671);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13672,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13672);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13667));
{
var G__13673 = seq__13659_13668;
var G__13674 = chunk__13660_13669;
var G__13675 = count__13661_13670;
var G__13676 = (i__13662_13671 + 1);
seq__13659_13668 = G__13673;
chunk__13660_13669 = G__13674;
count__13661_13670 = G__13675;
i__13662_13671 = G__13676;
continue;
}
} else
{var temp__4092__auto___13677 = cljs.core.seq.call(null,seq__13659_13668);if(temp__4092__auto___13677)
{var seq__13659_13678__$1 = temp__4092__auto___13677;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13659_13678__$1))
{var c__4262__auto___13679 = cljs.core.chunk_first.call(null,seq__13659_13678__$1);{
var G__13680 = cljs.core.chunk_rest.call(null,seq__13659_13678__$1);
var G__13681 = c__4262__auto___13679;
var G__13682 = cljs.core.count.call(null,c__4262__auto___13679);
var G__13683 = 0;
seq__13659_13668 = G__13680;
chunk__13660_13669 = G__13681;
count__13661_13670 = G__13682;
i__13662_13671 = G__13683;
continue;
}
} else
{var t_13684 = cljs.core.first.call(null,seq__13659_13678__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13684,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13684);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13667));
{
var G__13685 = cljs.core.next.call(null,seq__13659_13678__$1);
var G__13686 = null;
var G__13687 = 0;
var G__13688 = 0;
seq__13659_13668 = G__13685;
chunk__13660_13669 = G__13686;
count__13661_13670 = G__13687;
i__13662_13671 = G__13688;
continue;
}
}
} else
{}
}
break;
}
{
var G__13689 = seq__13651_13663;
var G__13690 = chunk__13656_13664;
var G__13691 = count__13657_13665;
var G__13692 = (i__13658_13666 + 1);
seq__13651_13663 = G__13689;
chunk__13656_13664 = G__13690;
count__13657_13665 = G__13691;
i__13658_13666 = G__13692;
continue;
}
} else
{var temp__4092__auto___13693 = cljs.core.seq.call(null,seq__13651_13663);if(temp__4092__auto___13693)
{var seq__13651_13694__$1 = temp__4092__auto___13693;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13651_13694__$1))
{var c__4262__auto___13695 = cljs.core.chunk_first.call(null,seq__13651_13694__$1);{
var G__13696 = cljs.core.chunk_rest.call(null,seq__13651_13694__$1);
var G__13697 = c__4262__auto___13695;
var G__13698 = cljs.core.count.call(null,c__4262__auto___13695);
var G__13699 = 0;
seq__13651_13663 = G__13696;
chunk__13656_13664 = G__13697;
count__13657_13665 = G__13698;
i__13658_13666 = G__13699;
continue;
}
} else
{var beh_13700 = cljs.core.first.call(null,seq__13651_13694__$1);var seq__13652_13701 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"triggers","triggers",2516997421).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,beh_13700)));var chunk__13653_13702 = null;var count__13654_13703 = 0;var i__13655_13704 = 0;while(true){
if((i__13655_13704 < count__13654_13703))
{var t_13705 = cljs.core._nth.call(null,chunk__13653_13702,i__13655_13704);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13705,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13705);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13700));
{
var G__13706 = seq__13652_13701;
var G__13707 = chunk__13653_13702;
var G__13708 = count__13654_13703;
var G__13709 = (i__13655_13704 + 1);
seq__13652_13701 = G__13706;
chunk__13653_13702 = G__13707;
count__13654_13703 = G__13708;
i__13655_13704 = G__13709;
continue;
}
} else
{var temp__4092__auto___13710__$1 = cljs.core.seq.call(null,seq__13652_13701);if(temp__4092__auto___13710__$1)
{var seq__13652_13711__$1 = temp__4092__auto___13710__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13652_13711__$1))
{var c__4262__auto___13712 = cljs.core.chunk_first.call(null,seq__13652_13711__$1);{
var G__13713 = cljs.core.chunk_rest.call(null,seq__13652_13711__$1);
var G__13714 = c__4262__auto___13712;
var G__13715 = cljs.core.count.call(null,c__4262__auto___13712);
var G__13716 = 0;
seq__13652_13701 = G__13713;
chunk__13653_13702 = G__13714;
count__13654_13703 = G__13715;
i__13655_13704 = G__13716;
continue;
}
} else
{var t_13717 = cljs.core.first.call(null,seq__13652_13711__$1);cljs.core.swap_BANG_.call(null,result,cljs.core.assoc_BANG_,t_13717,cljs.core.conj.call(null,(function (){var or__3520__auto__ = cljs.core.get.call(null,cljs.core.deref.call(null,result),t_13717);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.PersistentVector.EMPTY;
}
})(),beh_13700));
{
var G__13718 = cljs.core.next.call(null,seq__13652_13711__$1);
var G__13719 = null;
var G__13720 = 0;
var G__13721 = 0;
seq__13652_13701 = G__13718;
chunk__13653_13702 = G__13719;
count__13654_13703 = G__13720;
i__13655_13704 = G__13721;
continue;
}
}
} else
{}
}
break;
}
{
var G__13722 = cljs.core.next.call(null,seq__13651_13694__$1);
var G__13723 = null;
var G__13724 = 0;
var G__13725 = 0;
seq__13651_13663 = G__13722;
chunk__13656_13664 = G__13723;
count__13657_13665 = G__13724;
i__13658_13666 = G__13725;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.persistent_BANG_.call(null,cljs.core.deref.call(null,result));
});
lt.object.specificity_sort = (function() {
var specificity_sort = null;
var specificity_sort__1 = (function (xs){return specificity_sort.call(null,xs,null);
});
var specificity_sort__2 = (function (xs,dir){var arr = [];var seq__13730_13734 = cljs.core.seq.call(null,xs);var chunk__13731_13735 = null;var count__13732_13736 = 0;var i__13733_13737 = 0;while(true){
if((i__13733_13737 < count__13732_13736))
{var x_13738 = cljs.core._nth.call(null,chunk__13731_13735,i__13733_13737);arr.push([[cljs.core.str(x_13738)].join('').split(".").length,[cljs.core.str(x_13738)].join(''),x_13738]);
{
var G__13739 = seq__13730_13734;
var G__13740 = chunk__13731_13735;
var G__13741 = count__13732_13736;
var G__13742 = (i__13733_13737 + 1);
seq__13730_13734 = G__13739;
chunk__13731_13735 = G__13740;
count__13732_13736 = G__13741;
i__13733_13737 = G__13742;
continue;
}
} else
{var temp__4092__auto___13743 = cljs.core.seq.call(null,seq__13730_13734);if(temp__4092__auto___13743)
{var seq__13730_13744__$1 = temp__4092__auto___13743;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13730_13744__$1))
{var c__4262__auto___13745 = cljs.core.chunk_first.call(null,seq__13730_13744__$1);{
var G__13746 = cljs.core.chunk_rest.call(null,seq__13730_13744__$1);
var G__13747 = c__4262__auto___13745;
var G__13748 = cljs.core.count.call(null,c__4262__auto___13745);
var G__13749 = 0;
seq__13730_13734 = G__13746;
chunk__13731_13735 = G__13747;
count__13732_13736 = G__13748;
i__13733_13737 = G__13749;
continue;
}
} else
{var x_13750 = cljs.core.first.call(null,seq__13730_13744__$1);arr.push([[cljs.core.str(x_13750)].join('').split(".").length,[cljs.core.str(x_13750)].join(''),x_13750]);
{
var G__13751 = cljs.core.next.call(null,seq__13730_13744__$1);
var G__13752 = null;
var G__13753 = 0;
var G__13754 = 0;
seq__13730_13734 = G__13751;
chunk__13731_13735 = G__13752;
count__13732_13736 = G__13753;
i__13733_13737 = G__13754;
continue;
}
}
} else
{}
}
break;
}
arr.sort();
if(cljs.core.truth_(dir))
{} else
{arr.reverse();
}
var arr__3409__auto___13755 = arr;var i_13756 = 0;while(true){
if((i_13756 < arr__3409__auto___13755.length))
{(arr[i_13756] = (arr[i_13756][2]));
{
var G__13757 = (i_13756 + 1);
i_13756 = G__13757;
continue;
}
} else
{}
break;
}
return arr;
});
specificity_sort = function(xs,dir){
switch(arguments.length){
case 1:
return specificity_sort__1.call(this,xs);
case 2:
return specificity_sort__2.call(this,xs,dir);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
specificity_sort.cljs$core$IFn$_invoke$arity$1 = specificity_sort__1;
specificity_sort.cljs$core$IFn$_invoke$arity$2 = specificity_sort__2;
return specificity_sort;
})()
;
lt.object.ts__GT_negations = (function ts__GT_negations(ts){var seen = (function (){var obj13765 = {};return obj13765;
})();var seq__13766_13770 = cljs.core.seq.call(null,cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.negated_tags),ts)));var chunk__13767_13771 = null;var count__13768_13772 = 0;var i__13769_13773 = 0;while(true){
if((i__13769_13773 < count__13768_13772))
{var beh_13774 = cljs.core._nth.call(null,chunk__13767_13771,i__13769_13773);(seen[lt.object.__GT_behavior_name.call(null,beh_13774)] = true);
{
var G__13775 = seq__13766_13770;
var G__13776 = chunk__13767_13771;
var G__13777 = count__13768_13772;
var G__13778 = (i__13769_13773 + 1);
seq__13766_13770 = G__13775;
chunk__13767_13771 = G__13776;
count__13768_13772 = G__13777;
i__13769_13773 = G__13778;
continue;
}
} else
{var temp__4092__auto___13779 = cljs.core.seq.call(null,seq__13766_13770);if(temp__4092__auto___13779)
{var seq__13766_13780__$1 = temp__4092__auto___13779;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13766_13780__$1))
{var c__4262__auto___13781 = cljs.core.chunk_first.call(null,seq__13766_13780__$1);{
var G__13782 = cljs.core.chunk_rest.call(null,seq__13766_13780__$1);
var G__13783 = c__4262__auto___13781;
var G__13784 = cljs.core.count.call(null,c__4262__auto___13781);
var G__13785 = 0;
seq__13766_13770 = G__13782;
chunk__13767_13771 = G__13783;
count__13768_13772 = G__13784;
i__13769_13773 = G__13785;
continue;
}
} else
{var beh_13786 = cljs.core.first.call(null,seq__13766_13780__$1);(seen[lt.object.__GT_behavior_name.call(null,beh_13786)] = true);
{
var G__13787 = cljs.core.next.call(null,seq__13766_13780__$1);
var G__13788 = null;
var G__13789 = 0;
var G__13790 = 0;
seq__13766_13770 = G__13787;
chunk__13767_13771 = G__13788;
count__13768_13772 = G__13789;
i__13769_13773 = G__13790;
continue;
}
}
} else
{}
}
break;
}
return seen;
});
lt.object.tags__GT_behaviors = (function tags__GT_behaviors(ts){var duped = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),lt.object.specificity_sort.call(null,ts)));var de_duped = cljs.core.reduce.call(null,((function (duped){
return (function (res,cur){if(cljs.core.truth_((new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)])))
{return res;
} else
{var beh = lt.object.__GT_behavior.call(null,cur);if(cljs.core.truth_(new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{if(cljs.core.coll_QMARK_.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh)))
{var seq__13795_13799 = cljs.core.seq.call(null,new cljs.core.Keyword(null,"exclusive","exclusive",2700522000).cljs$core$IFn$_invoke$arity$1(beh));var chunk__13796_13800 = null;var count__13797_13801 = 0;var i__13798_13802 = 0;while(true){
if((i__13798_13802 < count__13797_13801))
{var exclude_13803 = cljs.core._nth.call(null,chunk__13796_13800,i__13798_13802);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_13803] = true);
{
var G__13804 = seq__13795_13799;
var G__13805 = chunk__13796_13800;
var G__13806 = count__13797_13801;
var G__13807 = (i__13798_13802 + 1);
seq__13795_13799 = G__13804;
chunk__13796_13800 = G__13805;
count__13797_13801 = G__13806;
i__13798_13802 = G__13807;
continue;
}
} else
{var temp__4092__auto___13808 = cljs.core.seq.call(null,seq__13795_13799);if(temp__4092__auto___13808)
{var seq__13795_13809__$1 = temp__4092__auto___13808;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13795_13809__$1))
{var c__4262__auto___13810 = cljs.core.chunk_first.call(null,seq__13795_13809__$1);{
var G__13811 = cljs.core.chunk_rest.call(null,seq__13795_13809__$1);
var G__13812 = c__4262__auto___13810;
var G__13813 = cljs.core.count.call(null,c__4262__auto___13810);
var G__13814 = 0;
seq__13795_13799 = G__13811;
chunk__13796_13800 = G__13812;
count__13797_13801 = G__13813;
i__13798_13802 = G__13814;
continue;
}
} else
{var exclude_13815 = cljs.core.first.call(null,seq__13795_13809__$1);(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[exclude_13815] = true);
{
var G__13816 = cljs.core.next.call(null,seq__13795_13809__$1);
var G__13817 = null;
var G__13818 = 0;
var G__13819 = 0;
seq__13795_13799 = G__13816;
chunk__13796_13800 = G__13817;
count__13797_13801 = G__13818;
i__13798_13802 = G__13819;
continue;
}
}
} else
{}
}
break;
}
} else
{}
(new cljs.core.Keyword(null,"seen","seen",1017430509).cljs$core$IFn$_invoke$arity$1(res)[lt.object.__GT_behavior_name.call(null,cur)] = true);
} else
{}
cljs.core.conj_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(res),cur);
return res;
}
});})(duped))
,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"seen","seen",1017430509),lt.object.ts__GT_negations.call(null,ts),new cljs.core.Keyword(null,"final","final",1111340264),cljs.core.transient$.call(null,cljs.core.PersistentVector.EMPTY)], null),duped);return cljs.core.reverse.call(null,cljs.core.persistent_BANG_.call(null,new cljs.core.Keyword(null,"final","final",1111340264).cljs$core$IFn$_invoke$arity$1(de_duped)));
});
lt.object.trigger__GT_behaviors = (function trigger__GT_behaviors(trig,ts){return cljs.core.get.call(null,lt.object.__GT_triggers.call(null,lt.object.tags__GT_behaviors.call(null,ts)),trig);
});
lt.object.safe_report_error = (function safe_report_error(e){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.error(e);
} else
{return console.error(((typeof e === 'string')?e:e.stack));
}
});
lt.object.raise_STAR_ = (function() {
var raise_STAR_ = null;
var raise_STAR___3 = (function (obj,reactions,args){return raise_STAR_.call(null,obj,reactions,args,null);
});
var raise_STAR___4 = (function (obj,reactions,args,trigger){var seq__13834 = cljs.core.seq.call(null,reactions);var chunk__13837 = null;var count__13838 = 0;var i__13839 = 0;while(true){
if((i__13839 < count__13838))
{var r = cljs.core._nth.call(null,chunk__13837,i__13839);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start13843_13848 = (new Date()).getTime();var _STAR_behavior_meta_STAR_13844_13849 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_13844_13849;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start13843_13848),trigger);
}
}catch (e13842){if((e13842 instanceof Error))
{var e_13850 = e13842;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_13850);
} else
{if((e13842 instanceof global.Error))
{var e_13851 = e13842;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_13851);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e13842;
} else
{}
}
}
}{
var G__13852 = seq__13834;
var G__13853 = chunk__13837;
var G__13854 = count__13838;
var G__13855 = (i__13839 + 1);
seq__13834 = G__13852;
chunk__13837 = G__13853;
count__13838 = G__13854;
i__13839 = G__13855;
continue;
}
} else
{{
var G__13856 = seq__13834;
var G__13857 = chunk__13837;
var G__13858 = count__13838;
var G__13859 = (i__13839 + 1);
seq__13834 = G__13856;
chunk__13837 = G__13857;
count__13838 = G__13858;
i__13839 = G__13859;
continue;
}
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13834);if(temp__4092__auto__)
{var seq__13834__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13834__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13834__$1);{
var G__13860 = cljs.core.chunk_rest.call(null,seq__13834__$1);
var G__13861 = c__4262__auto__;
var G__13862 = cljs.core.count.call(null,c__4262__auto__);
var G__13863 = 0;
seq__13834 = G__13860;
chunk__13837 = G__13861;
count__13838 = G__13862;
i__13839 = G__13863;
continue;
}
} else
{var r = cljs.core.first.call(null,seq__13834__$1);var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r));var args__$1 = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.concat.call(null,cljs.core.rest.call(null,r),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,r))?cljs.core.meta.call(null,r):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.truth_(func))
{try{var start13846_13864 = (new Date()).getTime();var _STAR_behavior_meta_STAR_13847_13865 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
cljs.core.apply.call(null,func,obj,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_13847_13865;
}if(cljs.core._EQ_.call(null,trigger,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588)))
{} else
{lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),r,((new Date()).getTime() - start13846_13864),trigger);
}
}catch (e13845){if((e13845 instanceof Error))
{var e_13866 = e13845;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_13866);
} else
{if((e13845 instanceof global.Error))
{var e_13867 = e13845;lt.object.safe_report_error.call(null,[cljs.core.str("Invalid behavior: "),cljs.core.str(new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,r)))].join(''));
lt.object.safe_report_error.call(null,e_13867);
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{throw e13845;
} else
{}
}
}
}{
var G__13868 = cljs.core.next.call(null,seq__13834__$1);
var G__13869 = null;
var G__13870 = 0;
var G__13871 = 0;
seq__13834 = G__13868;
chunk__13837 = G__13869;
count__13838 = G__13870;
i__13839 = G__13871;
continue;
}
} else
{{
var G__13872 = cljs.core.next.call(null,seq__13834__$1);
var G__13873 = null;
var G__13874 = 0;
var G__13875 = 0;
seq__13834 = G__13872;
chunk__13837 = G__13873;
count__13838 = G__13874;
i__13839 = G__13875;
continue;
}
}
}
} else
{return null;
}
}
break;
}
});
raise_STAR_ = function(obj,reactions,args,trigger){
switch(arguments.length){
case 3:
return raise_STAR___3.call(this,obj,reactions,args);
case 4:
return raise_STAR___4.call(this,obj,reactions,args,trigger);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
raise_STAR_.cljs$core$IFn$_invoke$arity$3 = raise_STAR___3;
raise_STAR_.cljs$core$IFn$_invoke$arity$4 = raise_STAR___4;
return raise_STAR_;
})()
;
/**
* Invoke object's behavior fns for given trigger. Args are passed to behavior fns
* @param {...*} var_args
*/
lt.object.raise = (function() { 
var raise__delegate = function (obj,k,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return lt.object.raise_STAR_.call(null,obj,reactions,args,k);
};
var raise = function (obj,k,var_args){
var args = null;if (arguments.length > 2) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return raise__delegate.call(this,obj,k,args);};
raise.cljs$lang$maxFixedArity = 2;
raise.cljs$lang$applyTo = (function (arglist__13876){
var obj = cljs.core.first(arglist__13876);
arglist__13876 = cljs.core.next(arglist__13876);
var k = cljs.core.first(arglist__13876);
var args = cljs.core.rest(arglist__13876);
return raise__delegate(obj,k,args);
});
raise.cljs$core$IFn$_invoke$arity$variadic = raise__delegate;
return raise;
})()
;
/**
* For a given behavior keyword id, call its :reaction fn with given args
* @param {...*} var_args
*/
lt.object.call_behavior_reaction = (function() { 
var call_behavior_reaction__delegate = function (id,args){var behavior_fn = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,id));if(cljs.core.truth_(behavior_fn))
{} else
{throw (new Error([cljs.core.str("Assert failed: "),cljs.core.str(cljs.core.pr_str.call(null,new cljs.core.Symbol(null,"behavior-fn","behavior-fn",-1300659236,null)))].join('')));
}
return cljs.core.apply.call(null,behavior_fn,args);
};
var call_behavior_reaction = function (id,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return call_behavior_reaction__delegate.call(this,id,args);};
call_behavior_reaction.cljs$lang$maxFixedArity = 1;
call_behavior_reaction.cljs$lang$applyTo = (function (arglist__13877){
var id = cljs.core.first(arglist__13877);
var args = cljs.core.rest(arglist__13877);
return call_behavior_reaction__delegate(id,args);
});
call_behavior_reaction.cljs$core$IFn$_invoke$arity$variadic = call_behavior_reaction__delegate;
return call_behavior_reaction;
})()
;
lt.object.update_listeners = (function() {
var update_listeners = null;
var update_listeners__1 = (function (obj){return update_listeners.call(null,obj,null);
});
var update_listeners__2 = (function (obj,instants){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.set.call(null,cljs.core.concat.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(cur),lt.object.tags__GT_behaviors.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cur))));var trigs = lt.object.__GT_triggers.call(null,behs);var trigs__$1 = (cljs.core.truth_(new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs))?(function (){lt.object.raise_STAR_.call(null,obj,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875).cljs$core$IFn$_invoke$arity$1(trigs),null,new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875));
return lt.object.__GT_triggers.call(null,behs);
})():trigs);var trigs__$2 = (cljs.core.truth_(instants)?trigs__$1:cljs.core.dissoc.call(null,trigs__$1,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"object.instant-load","object.instant-load",4025433875)));return cljs.core.assoc.call(null,cljs.core.deref.call(null,obj),new cljs.core.Keyword(null,"listeners","listeners",4090152369),trigs__$2);
});
update_listeners = function(obj,instants){
switch(arguments.length){
case 1:
return update_listeners__1.call(this,obj);
case 2:
return update_listeners__2.call(this,obj,instants);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
update_listeners.cljs$core$IFn$_invoke$arity$1 = update_listeners__1;
update_listeners.cljs$core$IFn$_invoke$arity$2 = update_listeners__2;
return update_listeners;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_object_STAR_ = (function() { 
var make_object_STAR___delegate = function (name,r){var obj = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.PersistentHashSet.EMPTY,new cljs.core.Keyword(null,"triggers","triggers",2516997421),cljs.core.PersistentVector.EMPTY,new cljs.core.Keyword(null,"listeners","listeners",4090152369),cljs.core.PersistentArrayMap.EMPTY,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666),name,new cljs.core.Keyword(null,"children","children",2673430897),cljs.core.PersistentArrayMap.EMPTY], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return obj;
};
var make_object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_object_STAR___delegate.call(this,name,r);};
make_object_STAR_.cljs$lang$maxFixedArity = 1;
make_object_STAR_.cljs$lang$applyTo = (function (arglist__13878){
var name = cljs.core.first(arglist__13878);
var r = cljs.core.rest(arglist__13878);
return make_object_STAR___delegate(name,r);
});
make_object_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_object_STAR___delegate;
return make_object_STAR_;
})()
;
lt.object.store_object_STAR_ = (function store_object_STAR_(obj){lt.object.add.call(null,obj);
return obj;
});
/**
* Return all objects for given type (template name)
*/
lt.object.instances_by_type = (function instances_by_type(type){return cljs.core.filter.call(null,(function (p1__13879_SHARP_){return cljs.core._EQ_.call(null,type,new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__13879_SHARP_)));
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances)));
});
/**
* Merge map into object
*/
lt.object.merge_BANG_ = (function merge_BANG_(obj,m){if(cljs.core.truth_((function (){var and__3508__auto__ = m;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.map_QMARK_.call(null,m));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Merge requires a map: "),cljs.core.str(m)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,cljs.core.merge,m);
});
lt.object.handle_redef = (function handle_redef(odef){var id = new cljs.core.Keyword("lt.object","type","lt.object/type",701613666).cljs$core$IFn$_invoke$arity$1(odef);var seq__13886_13892 = cljs.core.seq.call(null,lt.object.instances_by_type.call(null,id));var chunk__13888_13893 = null;var count__13889_13894 = 0;var i__13890_13895 = 0;while(true){
if((i__13890_13895 < count__13889_13894))
{var o_13896 = cljs.core._nth.call(null,chunk__13888_13893,i__13890_13895);var o_13897__$1 = cljs.core.deref.call(null,o_13896);var args_13898 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_13897__$1);var old_13899 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_13897__$1);var behs_13900 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_13897__$1));var inst_13901 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_13897__$1));var neue_13902 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_13901,args_13898):null);var neue_13903__$1 = ((cljs.core.vector_QMARK_.call(null,neue_13902))?crate.core.html.call(null,neue_13902):neue_13902);lt.object.merge_BANG_.call(null,inst_13901,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_13897__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_13900,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_13903__$1], null));
lt.object.merge_BANG_.call(null,inst_13901,lt.object.update_listeners.call(null,inst_13901));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_13899;if(cljs.core.truth_(and__3508__auto__))
{return neue_13903__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_13899,neue_13903__$1);
} else
{}
lt.object.raise.call(null,inst_13901,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__13904 = seq__13886_13892;
var G__13905 = chunk__13888_13893;
var G__13906 = count__13889_13894;
var G__13907 = (i__13890_13895 + 1);
seq__13886_13892 = G__13904;
chunk__13888_13893 = G__13905;
count__13889_13894 = G__13906;
i__13890_13895 = G__13907;
continue;
}
} else
{var temp__4092__auto___13908 = cljs.core.seq.call(null,seq__13886_13892);if(temp__4092__auto___13908)
{var seq__13886_13909__$1 = temp__4092__auto___13908;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13886_13909__$1))
{var c__4262__auto___13910 = cljs.core.chunk_first.call(null,seq__13886_13909__$1);{
var G__13911 = cljs.core.chunk_rest.call(null,seq__13886_13909__$1);
var G__13912 = c__4262__auto___13910;
var G__13913 = cljs.core.count.call(null,c__4262__auto___13910);
var G__13914 = 0;
seq__13886_13892 = G__13911;
chunk__13888_13893 = G__13912;
count__13889_13894 = G__13913;
i__13890_13895 = G__13914;
continue;
}
} else
{var o_13915 = cljs.core.first.call(null,seq__13886_13909__$1);var o_13916__$1 = cljs.core.deref.call(null,o_13915);var args_13917 = new cljs.core.Keyword(null,"args","args",1016906831).cljs$core$IFn$_invoke$arity$1(o_13916__$1);var old_13918 = new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(o_13916__$1);var behs_13919 = cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(o_13916__$1));var inst_13920 = cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o_13916__$1));var neue_13921 = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(odef),inst_13920,args_13917):null);var neue_13922__$1 = ((cljs.core.vector_QMARK_.call(null,neue_13921))?crate.core.html.call(null,neue_13921):neue_13921);lt.object.merge_BANG_.call(null,inst_13920,new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"tags","tags",1017456523),clojure.set.union.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(o_13916__$1),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(odef)),new cljs.core.Keyword(null,"behaviors","behaviors",607554515),clojure.set.union.call(null,behs_13919,cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(odef))),new cljs.core.Keyword(null,"content","content",1965434859),neue_13922__$1], null));
lt.object.merge_BANG_.call(null,inst_13920,lt.object.update_listeners.call(null,inst_13920));
if(cljs.core.truth_((function (){var and__3508__auto__ = old_13918;if(cljs.core.truth_(and__3508__auto__))
{return neue_13922__$1;
} else
{return and__3508__auto__;
}
})()))
{lt.util.dom.replace_with.call(null,old_13918,neue_13922__$1);
} else
{}
lt.object.raise.call(null,inst_13920,new cljs.core.Keyword(null,"redef","redef",1122293860));
{
var G__13923 = cljs.core.next.call(null,seq__13886_13909__$1);
var G__13924 = null;
var G__13925 = 0;
var G__13926 = 0;
seq__13886_13892 = G__13923;
chunk__13888_13893 = G__13924;
count__13889_13894 = G__13925;
i__13890_13895 = G__13926;
continue;
}
}
} else
{}
}
break;
}
return id;
});
/**
* Create object template (type) given keyword name and key-value pairs.
* These pairs serve as default attributes for an object. Following keys
* have special meaning:
* 
* * :behaviors - Set of object's behaviors
* * :tags - Set of object's tags
* * :triggers - Set of object's triggers
* * :init - Init fn called when object is created. Fn's return value
* is hiccup html content and saved to :content
* * :listeners (internal) - Map of triggers to vectors of behaviors
* @param {...*} var_args
*/
lt.object.object_STAR_ = (function() { 
var object_STAR___delegate = function (name,r){return lt.object.handle_redef.call(null,lt.object.store_object_STAR_.call(null,cljs.core.apply.call(null,lt.object.make_object_STAR_,name,r)));
};
var object_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return object_STAR___delegate.call(this,name,r);};
object_STAR_.cljs$lang$maxFixedArity = 1;
object_STAR_.cljs$lang$applyTo = (function (arglist__13927){
var name = cljs.core.first(arglist__13927);
var r = cljs.core.rest(arglist__13927);
return object_STAR___delegate(name,r);
});
object_STAR_.cljs$core$IFn$_invoke$arity$variadic = object_STAR___delegate;
return object_STAR_;
})()
;
/**
* @param {...*} var_args
*/
lt.object.make_behavior_STAR_ = (function() { 
var make_behavior_STAR___delegate = function (name,r){var be = cljs.core.merge.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"name","name",1017277949),name], null),cljs.core.apply.call(null,cljs.core.hash_map,r));return be;
};
var make_behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return make_behavior_STAR___delegate.call(this,name,r);};
make_behavior_STAR_.cljs$lang$maxFixedArity = 1;
make_behavior_STAR_.cljs$lang$applyTo = (function (arglist__13928){
var name = cljs.core.first(arglist__13928);
var r = cljs.core.rest(arglist__13928);
return make_behavior_STAR___delegate(name,r);
});
make_behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = make_behavior_STAR___delegate;
return make_behavior_STAR_;
})()
;
lt.object.store_behavior_STAR_ = (function store_behavior_STAR_(beh){lt.object.add_behavior.call(null,beh);
return new cljs.core.Keyword(null,"name","name",1017277949).cljs$core$IFn$_invoke$arity$1(beh);
});
lt.object.wrap_throttle = (function wrap_throttle(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"throttle","throttle",2497347228).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.throttle.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
lt.object.wrap_debounce = (function wrap_debounce(beh){var temp__4090__auto__ = new cljs.core.Keyword(null,"debounce","debounce",1556599227).cljs$core$IFn$_invoke$arity$1(beh);if(cljs.core.truth_(temp__4090__auto__))
{var thr = temp__4090__auto__;return cljs.core.assoc.call(null,beh,new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.util.js.debounce.call(null,thr,new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(beh)));
} else
{return beh;
}
});
/**
* @param {...*} var_args
*/
lt.object.behavior_STAR_ = (function() { 
var behavior_STAR___delegate = function (name,r){return lt.object.store_behavior_STAR_.call(null,lt.object.wrap_debounce.call(null,lt.object.wrap_throttle.call(null,cljs.core.apply.call(null,lt.object.make_behavior_STAR_,name,r))));
};
var behavior_STAR_ = function (name,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return behavior_STAR___delegate.call(this,name,r);};
behavior_STAR_.cljs$lang$maxFixedArity = 1;
behavior_STAR_.cljs$lang$applyTo = (function (arglist__13929){
var name = cljs.core.first(arglist__13929);
var r = cljs.core.rest(arglist__13929);
return behavior_STAR___delegate(name,r);
});
behavior_STAR_.cljs$core$IFn$_invoke$arity$variadic = behavior_STAR___delegate;
return behavior_STAR_;
})()
;
/**
* Reduce over invoked object's behavior fns for given trigger. Start
* is initial value for reduce and any args are passed to behavior fn
* @param {...*} var_args
*/
lt.object.raise_reduce = (function() { 
var raise_reduce__delegate = function (obj,k,start,args){var reactions = k.call(null,new cljs.core.Keyword(null,"listeners","listeners",4090152369).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)));return cljs.core.reduce.call(null,(function (res,cur){var func = new cljs.core.Keyword(null,"reaction","reaction",4441361819).cljs$core$IFn$_invoke$arity$1(lt.object.__GT_behavior.call(null,cur));var args__$1 = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.concat.call(null,cljs.core.rest.call(null,cur),args):args);var meta = ((cljs.core.coll_QMARK_.call(null,cur))?cljs.core.meta.call(null,cur):cljs.core.PersistentArrayMap.EMPTY);if(cljs.core.not.call(null,func))
{return res;
} else
{var _STAR_behavior_meta_STAR_13931 = lt.object._STAR_behavior_meta_STAR_;try{lt.object._STAR_behavior_meta_STAR_ = meta;
return cljs.core.apply.call(null,func,obj,res,args__$1);
}finally {lt.object._STAR_behavior_meta_STAR_ = _STAR_behavior_meta_STAR_13931;
}}
}),start,reactions);
};
var raise_reduce = function (obj,k,start,var_args){
var args = null;if (arguments.length > 3) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 3),0);} 
return raise_reduce__delegate.call(this,obj,k,start,args);};
raise_reduce.cljs$lang$maxFixedArity = 3;
raise_reduce.cljs$lang$applyTo = (function (arglist__13932){
var obj = cljs.core.first(arglist__13932);
arglist__13932 = cljs.core.next(arglist__13932);
var k = cljs.core.first(arglist__13932);
arglist__13932 = cljs.core.next(arglist__13932);
var start = cljs.core.first(arglist__13932);
var args = cljs.core.rest(arglist__13932);
return raise_reduce__delegate(obj,k,start,args);
});
raise_reduce.cljs$core$IFn$_invoke$arity$variadic = raise_reduce__delegate;
return raise_reduce;
})()
;
/**
* Update object with update-in with [:key], fn and args
* @param {...*} var_args
*/
lt.object.update_BANG_ = (function() { 
var update_BANG___delegate = function (obj,r){return cljs.core.swap_BANG_.call(null,obj,(function (p1__13933_SHARP_){return cljs.core.apply.call(null,cljs.core.update_in,p1__13933_SHARP_,r);
}));
};
var update_BANG_ = function (obj,var_args){
var r = null;if (arguments.length > 1) {
  r = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return update_BANG___delegate.call(this,obj,r);};
update_BANG_.cljs$lang$maxFixedArity = 1;
update_BANG_.cljs$lang$applyTo = (function (arglist__13934){
var obj = cljs.core.first(arglist__13934);
var r = cljs.core.rest(arglist__13934);
return update_BANG___delegate(obj,r);
});
update_BANG_.cljs$core$IFn$_invoke$arity$variadic = update_BANG___delegate;
return update_BANG_;
})()
;
/**
* Update object with assoc-in for given key and value
*/
lt.object.assoc_in_BANG_ = (function assoc_in_BANG_(obj,k,v){if(cljs.core.truth_((function (){var and__3508__auto__ = k;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.sequential_QMARK_.call(null,k));
} else
{return and__3508__auto__;
}
})()))
{throw (new Error([cljs.core.str("Associate requires a sequence of keys: "),cljs.core.str(k)].join('')));
} else
{}
return cljs.core.swap_BANG_.call(null,obj,(function (p1__13935_SHARP_){return cljs.core.assoc_in.call(null,p1__13935_SHARP_,k,v);
}));
});
lt.object.__GT_inst = (function __GT_inst(o){if(cljs.core.map_QMARK_.call(null,o))
{return cljs.core.deref.call(null,lt.object.instances).call(null,lt.object.__GT_id.call(null,o));
} else
{if(crate.binding.deref_QMARK_.call(null,o))
{return o;
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return cljs.core.deref.call(null,lt.object.instances).call(null,o);
} else
{return null;
}
}
}
});
/**
* Return DOM content associated with object
*/
lt.object.__GT_content = (function __GT_content(obj){return new cljs.core.Keyword(null,"content","content",1965434859).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj));
});
/**
* Destroy object by calling its :destroy trigger, removing it from
* cache and removing associated DOM content
*/
lt.object.destroy_BANG_ = (function destroy_BANG_(obj){var temp__4092__auto__ = lt.object.__GT_inst.call(null,obj);if(cljs.core.truth_(temp__4092__auto__))
{var inst = temp__4092__auto__;lt.object.raise.call(null,inst,new cljs.core.Keyword(null,"destroy","destroy",2571277164));
cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.dissoc,lt.object.__GT_id.call(null,inst));
if(cljs.core.truth_(lt.object.__GT_content.call(null,obj)))
{lt.util.dom.remove.call(null,lt.object.__GT_content.call(null,obj));
} else
{}
return cljs.core.reset_BANG_.call(null,obj,null);
} else
{return null;
}
});
lt.object.store_inst = (function store_inst(inst){cljs.core.swap_BANG_.call(null,lt.object.instances,cljs.core.assoc,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst)),inst);
return inst;
});
/**
* Create object given keyword name of object template or an object template
* and key-value pairs. See object* for special keys.
* During object creation the following happens to object in order:
* 
* * :init fn is called with given args
* * :object.instant trigger is raised
* * :init trigger is raised
* @param {...*} var_args
*/
lt.object.create = (function() { 
var create__delegate = function (obj_name,args){var obj = (((obj_name instanceof cljs.core.Keyword))?cljs.core.deref.call(null,lt.object.object_defs).call(null,obj_name):obj_name);var id = (function (){var or__3520__auto__ = new cljs.core.Keyword("lt.object","id","lt.object/id",706431105).cljs$core$IFn$_invoke$arity$1(obj);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.swap_BANG_.call(null,lt.object.obj_id,cljs.core.inc);
}
})();var inst = cljs.core.atom.call(null,cljs.core.assoc.call(null,cljs.core.dissoc.call(null,obj,new cljs.core.Keyword(null,"init","init",1017141378)),new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),id,new cljs.core.Keyword(null,"args","args",1016906831),args,new cljs.core.Keyword(null,"behaviors","behaviors",607554515),cljs.core.set.call(null,new cljs.core.Keyword(null,"behaviors","behaviors",607554515).cljs$core$IFn$_invoke$arity$1(obj)),new cljs.core.Keyword(null,"tags","tags",1017456523),cljs.core.set.call(null,cljs.core.conj.call(null,new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(obj),new cljs.core.Keyword(null,"object","object",4285503153)))));var inst__$1 = lt.object.store_inst.call(null,inst);var _ = lt.object.merge_BANG_.call(null,inst__$1,lt.object.update_listeners.call(null,inst__$1));var content = (cljs.core.truth_(new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj))?cljs.core.apply.call(null,new cljs.core.Keyword(null,"init","init",1017141378).cljs$core$IFn$_invoke$arity$1(obj),inst__$1,args):null);var content__$1 = ((cljs.core.vector_QMARK_.call(null,content))?crate.core.html.call(null,content):content);var final$ = lt.object.merge_BANG_.call(null,inst__$1,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"content","content",1965434859),content__$1], null));cljs.core.add_watch.call(null,inst__$1,new cljs.core.Keyword("lt.object","change","lt.object/change",2456955616),(function (___$1,___$2,___$3,___$4){return lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"object.change","object.change",966833329));
}));
lt.object.raise_STAR_.call(null,inst__$1,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,inst__$1))),null);
lt.object.raise.call(null,inst__$1,new cljs.core.Keyword(null,"init","init",1017141378));
return inst__$1;
};
var create = function (obj_name,var_args){
var args = null;if (arguments.length > 1) {
  args = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return create__delegate.call(this,obj_name,args);};
create.cljs$lang$maxFixedArity = 1;
create.cljs$lang$applyTo = (function (arglist__13936){
var obj_name = cljs.core.first(arglist__13936);
var args = cljs.core.rest(arglist__13936);
return create__delegate(obj_name,args);
});
create.cljs$core$IFn$_invoke$arity$variadic = create__delegate;
return create;
})()
;
lt.object.refresh_BANG_ = (function refresh_BANG_(obj){cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj))),null);
return lt.object.raise.call(null,obj,new cljs.core.Keyword(null,"object.refresh","object.refresh",4196174494));
});
/**
* Add behavior to object and update its listeners
*/
lt.object.add_behavior_BANG_ = (function add_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),cljs.core.conj,behavior);
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
/**
* Remove behavior from object and update its listeners
*/
lt.object.rem_behavior_BANG_ = (function rem_behavior_BANG_(obj,behavior){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),(function (p1__13937_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),p1__13937_SHARP_);
}));
return cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
});
lt.object.__GT_def = (function __GT_def(def_BAR_name){if(cljs.core.map_QMARK_.call(null,def_BAR_name))
{return def_BAR_name;
} else
{return cljs.core.deref.call(null,lt.object.object_defs).call(null,def_BAR_name);
}
});
/**
* Find object by its unique numerical id
*/
lt.object.by_id = (function by_id(id){if(cljs.core.truth_(id))
{return cljs.core.deref.call(null,lt.object.instances).call(null,id);
} else
{return null;
}
});
/**
* Find objects that have given tag
*/
lt.object.by_tag = (function by_tag(tag){return cljs.core.sort_by.call(null,cljs.core.comp.call(null,new cljs.core.Keyword("lt.object","id","lt.object/id",706431105),cljs.core.deref),cljs.core.filter.call(null,(function (p1__13938_SHARP_){var temp__4092__auto__ = new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,p1__13938_SHARP_));if(cljs.core.truth_(temp__4092__auto__))
{var ts = temp__4092__auto__;return ts.call(null,tag);
} else
{return null;
}
}),cljs.core.vals.call(null,cljs.core.deref.call(null,lt.object.instances))));
});
lt.object.in_tag_QMARK_ = (function in_tag_QMARK_(tag,behavior){return cljs.core.first.call(null,cljs.core.filter.call(null,cljs.core.PersistentHashSet.fromArray([behavior], true),cljs.core.deref.call(null,lt.object.tags).call(null,tag)));
});
/**
* Return truthy if object has tag
*/
lt.object.has_tag_QMARK_ = (function has_tag_QMARK_(obj,tag){return new cljs.core.Keyword(null,"tags","tags",1017456523).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,obj)).call(null,tag);
});
/**
* Add tags to given object and updates effected behaviors and listeners.
* ::tags-added trigger is raised on object after update
*/
lt.object.add_tags = (function add_tags(obj,ts){lt.object.update_BANG_.call(null,obj,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),(function (p1__13939_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,p1__13939_SHARP_,cljs.core.filter.call(null,cljs.core.identity,ts));
}));
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),ts);
lt.object.raise_STAR_.call(null,obj,lt.object.trigger__GT_behaviors.call(null,new cljs.core.Keyword(null,"object.instant","object.instant",773332388),ts),null);
return obj;
});
/**
* Remove tags from given object and updates effected behaviors and listeners.
* ::tags-removed trigger is raised on object after update
*/
lt.object.remove_tags = (function remove_tags(obj,ts){var cur = cljs.core.deref.call(null,obj);var behs = cljs.core.apply.call(null,cljs.core.concat,cljs.core.map.call(null,cljs.core.deref.call(null,lt.object.tags),ts));var cur__$1 = cljs.core.update_in.call(null,cljs.core.update_in.call(null,cljs.core.update_in.call(null,cur,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"tags","tags",1017456523)], null),((function (cur,behs){
return (function (p1__13940_SHARP_){return cljs.core.reduce.call(null,cljs.core.disj,p1__13940_SHARP_,ts);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"behaviors","behaviors",607554515)], null),((function (cur,behs){
return (function (p1__13941_SHARP_){return cljs.core.remove.call(null,cljs.core.PersistentHashSet.fromArray([behs], true),p1__13941_SHARP_);
});})(cur,behs))
),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"listeners","listeners",4090152369)], null),((function (cur,behs){
return (function (p1__13942_SHARP_){return cljs.core.apply.call(null,cljs.core.dissoc,p1__13942_SHARP_,ts);
});})(cur,behs))
);lt.object.merge_BANG_.call(null,obj,cur__$1);
cljs.core.reset_BANG_.call(null,obj,lt.object.update_listeners.call(null,obj));
lt.object.raise.call(null,obj,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),ts);
return obj;
});
/**
* Associate behaviors to given tag and refresh objects with given tag
*/
lt.object.tag_behaviors = (function tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__13943_SHARP_){return cljs.core.reduce.call(null,cljs.core.conj,(function (){var or__3520__auto__ = p1__13943_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})(),behs);
}));
var seq__13948_13952 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__13949_13953 = null;var count__13950_13954 = 0;var i__13951_13955 = 0;while(true){
if((i__13951_13955 < count__13950_13954))
{var cur_13956 = cljs.core._nth.call(null,chunk__13949_13953,i__13951_13955);lt.object.refresh_BANG_.call(null,cur_13956);
{
var G__13957 = seq__13948_13952;
var G__13958 = chunk__13949_13953;
var G__13959 = count__13950_13954;
var G__13960 = (i__13951_13955 + 1);
seq__13948_13952 = G__13957;
chunk__13949_13953 = G__13958;
count__13950_13954 = G__13959;
i__13951_13955 = G__13960;
continue;
}
} else
{var temp__4092__auto___13961 = cljs.core.seq.call(null,seq__13948_13952);if(temp__4092__auto___13961)
{var seq__13948_13962__$1 = temp__4092__auto___13961;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13948_13962__$1))
{var c__4262__auto___13963 = cljs.core.chunk_first.call(null,seq__13948_13962__$1);{
var G__13964 = cljs.core.chunk_rest.call(null,seq__13948_13962__$1);
var G__13965 = c__4262__auto___13963;
var G__13966 = cljs.core.count.call(null,c__4262__auto___13963);
var G__13967 = 0;
seq__13948_13952 = G__13964;
chunk__13949_13953 = G__13965;
count__13950_13954 = G__13966;
i__13951_13955 = G__13967;
continue;
}
} else
{var cur_13968 = cljs.core.first.call(null,seq__13948_13962__$1);lt.object.refresh_BANG_.call(null,cur_13968);
{
var G__13969 = cljs.core.next.call(null,seq__13948_13962__$1);
var G__13970 = null;
var G__13971 = 0;
var G__13972 = 0;
seq__13948_13952 = G__13969;
chunk__13949_13953 = G__13970;
count__13950_13954 = G__13971;
i__13951_13955 = G__13972;
continue;
}
}
} else
{}
}
break;
}
return cljs.core.deref.call(null,lt.object.tags).call(null,tag);
});
lt.object.remove_tag_behaviors = (function remove_tag_behaviors(tag,behs){cljs.core.swap_BANG_.call(null,lt.object.tags,cljs.core.update_in,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [tag], null),(function (p1__13973_SHARP_){return cljs.core.remove.call(null,cljs.core.set.call(null,behs),(function (){var or__3520__auto__ = p1__13973_SHARP_;if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return cljs.core.List.EMPTY;
}
})());
}));
var seq__13986 = cljs.core.seq.call(null,lt.object.by_tag.call(null,tag));var chunk__13991 = null;var count__13992 = 0;var i__13993 = 0;while(true){
if((i__13993 < count__13992))
{var cur = cljs.core._nth.call(null,chunk__13991,i__13993);var seq__13994_13998 = cljs.core.seq.call(null,behs);var chunk__13995_13999 = null;var count__13996_14000 = 0;var i__13997_14001 = 0;while(true){
if((i__13997_14001 < count__13996_14000))
{var b_14002 = cljs.core._nth.call(null,chunk__13995_13999,i__13997_14001);lt.object.rem_behavior_BANG_.call(null,cur,b_14002);
{
var G__14003 = seq__13994_13998;
var G__14004 = chunk__13995_13999;
var G__14005 = count__13996_14000;
var G__14006 = (i__13997_14001 + 1);
seq__13994_13998 = G__14003;
chunk__13995_13999 = G__14004;
count__13996_14000 = G__14005;
i__13997_14001 = G__14006;
continue;
}
} else
{var temp__4092__auto___14007 = cljs.core.seq.call(null,seq__13994_13998);if(temp__4092__auto___14007)
{var seq__13994_14008__$1 = temp__4092__auto___14007;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13994_14008__$1))
{var c__4262__auto___14009 = cljs.core.chunk_first.call(null,seq__13994_14008__$1);{
var G__14010 = cljs.core.chunk_rest.call(null,seq__13994_14008__$1);
var G__14011 = c__4262__auto___14009;
var G__14012 = cljs.core.count.call(null,c__4262__auto___14009);
var G__14013 = 0;
seq__13994_13998 = G__14010;
chunk__13995_13999 = G__14011;
count__13996_14000 = G__14012;
i__13997_14001 = G__14013;
continue;
}
} else
{var b_14014 = cljs.core.first.call(null,seq__13994_14008__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14014);
{
var G__14015 = cljs.core.next.call(null,seq__13994_14008__$1);
var G__14016 = null;
var G__14017 = 0;
var G__14018 = 0;
seq__13994_13998 = G__14015;
chunk__13995_13999 = G__14016;
count__13996_14000 = G__14017;
i__13997_14001 = G__14018;
continue;
}
}
} else
{}
}
break;
}
{
var G__14019 = seq__13986;
var G__14020 = chunk__13991;
var G__14021 = count__13992;
var G__14022 = (i__13993 + 1);
seq__13986 = G__14019;
chunk__13991 = G__14020;
count__13992 = G__14021;
i__13993 = G__14022;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13986);if(temp__4092__auto__)
{var seq__13986__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13986__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13986__$1);{
var G__14023 = cljs.core.chunk_rest.call(null,seq__13986__$1);
var G__14024 = c__4262__auto__;
var G__14025 = cljs.core.count.call(null,c__4262__auto__);
var G__14026 = 0;
seq__13986 = G__14023;
chunk__13991 = G__14024;
count__13992 = G__14025;
i__13993 = G__14026;
continue;
}
} else
{var cur = cljs.core.first.call(null,seq__13986__$1);var seq__13987_14027 = cljs.core.seq.call(null,behs);var chunk__13988_14028 = null;var count__13989_14029 = 0;var i__13990_14030 = 0;while(true){
if((i__13990_14030 < count__13989_14029))
{var b_14031 = cljs.core._nth.call(null,chunk__13988_14028,i__13990_14030);lt.object.rem_behavior_BANG_.call(null,cur,b_14031);
{
var G__14032 = seq__13987_14027;
var G__14033 = chunk__13988_14028;
var G__14034 = count__13989_14029;
var G__14035 = (i__13990_14030 + 1);
seq__13987_14027 = G__14032;
chunk__13988_14028 = G__14033;
count__13989_14029 = G__14034;
i__13990_14030 = G__14035;
continue;
}
} else
{var temp__4092__auto___14036__$1 = cljs.core.seq.call(null,seq__13987_14027);if(temp__4092__auto___14036__$1)
{var seq__13987_14037__$1 = temp__4092__auto___14036__$1;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13987_14037__$1))
{var c__4262__auto___14038 = cljs.core.chunk_first.call(null,seq__13987_14037__$1);{
var G__14039 = cljs.core.chunk_rest.call(null,seq__13987_14037__$1);
var G__14040 = c__4262__auto___14038;
var G__14041 = cljs.core.count.call(null,c__4262__auto___14038);
var G__14042 = 0;
seq__13987_14027 = G__14039;
chunk__13988_14028 = G__14040;
count__13989_14029 = G__14041;
i__13990_14030 = G__14042;
continue;
}
} else
{var b_14043 = cljs.core.first.call(null,seq__13987_14037__$1);lt.object.rem_behavior_BANG_.call(null,cur,b_14043);
{
var G__14044 = cljs.core.next.call(null,seq__13987_14037__$1);
var G__14045 = null;
var G__14046 = 0;
var G__14047 = 0;
seq__13987_14027 = G__14044;
chunk__13988_14028 = G__14045;
count__13989_14029 = G__14046;
i__13990_14030 = G__14047;
continue;
}
}
} else
{}
}
break;
}
{
var G__14048 = cljs.core.next.call(null,seq__13986__$1);
var G__14049 = null;
var G__14050 = 0;
var G__14051 = 0;
seq__13986 = G__14048;
chunk__13991 = G__14049;
count__13992 = G__14050;
i__13993 = G__14051;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.object.__BEH__add_tag = (function __BEH__add_tag(this$,t){if(cljs.core.truth_(t))
{return lt.object.add_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","add-tag","lt.object/add-tag",1703923742),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__add_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Add tag to object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__remove_tag = (function __BEH__remove_tag(this$,t){if(cljs.core.truth_(lt.object.has_tag_QMARK_.call(null,this$,t)))
{return lt.object.remove_tags.call(null,this$,((cljs.core.coll_QMARK_.call(null,t))?t:new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [t], null)));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","remove-tag","lt.object/remove-tag",3883925951),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__remove_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Remove tag from object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__shadow_tag = (function __BEH__shadow_tag(this$,to_shadow,to_add){var has_shadow_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_shadow);var has_add_QMARK_ = lt.object.has_tag_QMARK_.call(null,this$,to_add);if(cljs.core.truth_((function (){var and__3508__auto__ = has_shadow_QMARK_;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not.call(null,has_add_QMARK_);
} else
{return and__3508__auto__;
}
})()))
{return lt.object.add_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(cljs.core.truth_((function (){var and__3508__auto__ = cljs.core.not.call(null,has_shadow_QMARK_);if(and__3508__auto__)
{return has_add_QMARK_;
} else
{return and__3508__auto__;
}
})()))
{return lt.object.remove_tags.call(null,this$,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [to_add], null));
} else
{if(new cljs.core.Keyword(null,"else","else",1017020587))
{return null;
} else
{return null;
}
}
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","shadow-tag","lt.object/shadow-tag",1731213395),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__shadow_tag,new cljs.core.Keyword(null,"desc","desc",1016984067),"App: Shadow a tag on an object",new cljs.core.Keyword(null,"params","params",4313443576),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to shadow"], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"label","label",1116631654),"tag to add"], null)], null),new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 3, [new cljs.core.Keyword(null,"object.instant","object.instant",773332388),null,new cljs.core.Keyword("lt.object","tags-added","lt.object/tags-added",1756253556),null,new cljs.core.Keyword("lt.object","tags-removed","lt.object/tags-removed",4080090644),null], null), null),new cljs.core.Keyword(null,"type","type",1017479852),new cljs.core.Keyword(null,"user","user",1017503549));
lt.object.__BEH__report_time = (function __BEH__report_time(this$,beh,time,trigger){if(cljs.core.truth_(lt.objs.console))
{return lt.objs.console.log([cljs.core.str(beh),cljs.core.str(" triggered by "),cljs.core.str(trigger),cljs.core.str(" took "),cljs.core.str(time),cljs.core.str("ms")].join(''));
} else
{return null;
}
});
lt.object.behavior_STAR_.call(null,new cljs.core.Keyword("lt.object","report-time","lt.object/report-time",1387009782),new cljs.core.Keyword(null,"reaction","reaction",4441361819),lt.object.__BEH__report_time,new cljs.core.Keyword(null,"triggers","triggers",2516997421),new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"object.behavior.time","object.behavior.time",854340588),null], null), null));
