// Compiled by ClojureScript 0.0-2138
goog.provide('lt.util.dom');
goog.require('cljs.core');
lt.util.dom.lazy_nl_via_item = (function() {
var lazy_nl_via_item = null;
var lazy_nl_via_item__1 = (function (nl){return lazy_nl_via_item.call(null,nl,0);
});
var lazy_nl_via_item__2 = (function (nl,n){if((n < nl.length))
{return (new cljs.core.LazySeq(null,(function (){return cljs.core.cons.call(null,nl.item(n),lazy_nl_via_item.call(null,nl,(n + 1)));
}),null,null));
} else
{return null;
}
});
lazy_nl_via_item = function(nl,n){
switch(arguments.length){
case 1:
return lazy_nl_via_item__1.call(this,nl);
case 2:
return lazy_nl_via_item__2.call(this,nl,n);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$1 = lazy_nl_via_item__1;
lazy_nl_via_item.cljs$core$IFn$_invoke$arity$2 = lazy_nl_via_item__2;
return lazy_nl_via_item;
})()
;
HTMLCollection.prototype.cljs$core$IIndexed$ = true;
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
HTMLCollection.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
HTMLCollection.prototype.cljs$core$ICounted$ = true;
HTMLCollection.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
HTMLCollection.prototype.cljs$core$ISeqable$ = true;
HTMLCollection.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
NodeList.prototype.cljs$core$IIndexed$ = true;
NodeList.prototype.cljs$core$IIndexed$_nth$arity$2 = (function (this$,n){var this$__$1 = this;return this$__$1.item(n);
});
NodeList.prototype.cljs$core$IIndexed$_nth$arity$3 = (function (this$,n,not_found){var this$__$1 = this;var or__3520__auto__ = this$__$1.item(n);if(cljs.core.truth_(or__3520__auto__))
{return or__3520__auto__;
} else
{return not_found;
}
});
NodeList.prototype.cljs$core$ICounted$ = true;
NodeList.prototype.cljs$core$ICounted$_count$arity$1 = (function (this$){var this$__$1 = this;return this$__$1.length;
});
NodeList.prototype.cljs$core$ISeqable$ = true;
NodeList.prototype.cljs$core$ISeqable$_seq$arity$1 = (function (this$){var this$__$1 = this;return lt.util.dom.lazy_nl_via_item.call(null,this$__$1);
});
lt.util.dom.text_node = (function text_node(text){return document.createTextNode(text);
});
lt.util.dom.$$ = (function() {
var $$ = null;
var $$__1 = (function (query){return $$.call(null,query,document);
});
var $$__2 = (function (query,elem){return elem.querySelectorAll(cljs.core.name.call(null,query));
});
$$ = function(query,elem){
switch(arguments.length){
case 1:
return $$__1.call(this,query);
case 2:
return $$__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$$.cljs$core$IFn$_invoke$arity$1 = $$__1;
$$.cljs$core$IFn$_invoke$arity$2 = $$__2;
return $$;
})()
;
lt.util.dom.$ = (function() {
var $ = null;
var $__1 = (function (query){return $.call(null,query,document);
});
var $__2 = (function (query,elem){return elem.querySelector(cljs.core.name.call(null,query));
});
$ = function(query,elem){
switch(arguments.length){
case 1:
return $__1.call(this,query);
case 2:
return $__2.call(this,query,elem);
}
throw(new Error('Invalid arity: ' + arguments.length));
};
$.cljs$core$IFn$_invoke$arity$1 = $__1;
$.cljs$core$IFn$_invoke$arity$2 = $__2;
return $;
})()
;
lt.util.dom.append = (function append(parent,child){parent.appendChild(child);
return parent;
});
lt.util.dom.prepend = (function prepend(parent,child){if(cljs.core.truth_(parent.firstChild))
{return parent.insertBefore(child,parent.firstChild);
} else
{return lt.util.dom.append.call(null,parent,child);
}
});
lt.util.dom.add_class = (function add_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.add(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.remove_class = (function remove_class(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.remove(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.has_class_QMARK_ = (function has_class_QMARK_(elem,class$){if(cljs.core.truth_((function (){var and__3508__auto__ = elem;if(cljs.core.truth_(and__3508__auto__))
{return !(cljs.core.empty_QMARK_.call(null,cljs.core.name.call(null,class$)));
} else
{return and__3508__auto__;
}
})()))
{return elem.classList.contains(cljs.core.name.call(null,class$));
} else
{return null;
}
});
lt.util.dom.toggle_class = (function toggle_class(elem,class$){if(cljs.core.truth_(lt.util.dom.has_class_QMARK_.call(null,elem,class$)))
{return lt.util.dom.remove_class.call(null,elem,class$);
} else
{return lt.util.dom.add_class.call(null,elem,class$);
}
});
lt.util.dom.set_css = (function set_css(elem,things){var seq__13508 = cljs.core.seq.call(null,things);var chunk__13509 = null;var count__13510 = 0;var i__13511 = 0;while(true){
if((i__13511 < count__13510))
{var vec__13512 = cljs.core._nth.call(null,chunk__13509,i__13511);var k = cljs.core.nth.call(null,vec__13512,0,null);var v = cljs.core.nth.call(null,vec__13512,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13514 = seq__13508;
var G__13515 = chunk__13509;
var G__13516 = count__13510;
var G__13517 = (i__13511 + 1);
seq__13508 = G__13514;
chunk__13509 = G__13515;
count__13510 = G__13516;
i__13511 = G__13517;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13508);if(temp__4092__auto__)
{var seq__13508__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13508__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13508__$1);{
var G__13518 = cljs.core.chunk_rest.call(null,seq__13508__$1);
var G__13519 = c__4262__auto__;
var G__13520 = cljs.core.count.call(null,c__4262__auto__);
var G__13521 = 0;
seq__13508 = G__13518;
chunk__13509 = G__13519;
count__13510 = G__13520;
i__13511 = G__13521;
continue;
}
} else
{var vec__13513 = cljs.core.first.call(null,seq__13508__$1);var k = cljs.core.nth.call(null,vec__13513,0,null);var v = cljs.core.nth.call(null,vec__13513,1,null);(elem.style[cljs.core.name.call(null,k)] = (((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13522 = cljs.core.next.call(null,seq__13508__$1);
var G__13523 = null;
var G__13524 = 0;
var G__13525 = 0;
seq__13508 = G__13522;
chunk__13509 = G__13523;
count__13510 = G__13524;
i__13511 = G__13525;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.css = (function css(elem,things){var things__$1 = ((cljs.core._EQ_.call(null,Object,cljs.core.type.call(null,things)))?cljs.core.js__GT_clj.call(null,things):things);if(cljs.core.map_QMARK_.call(null,things__$1))
{return lt.util.dom.set_css.call(null,elem,things__$1);
} else
{return (elem.style[cljs.core.name.call(null,things__$1)]);
}
});
lt.util.dom.set_attr = (function set_attr(elem,things){var seq__13532 = cljs.core.seq.call(null,things);var chunk__13533 = null;var count__13534 = 0;var i__13535 = 0;while(true){
if((i__13535 < count__13534))
{var vec__13536 = cljs.core._nth.call(null,chunk__13533,i__13535);var k = cljs.core.nth.call(null,vec__13536,0,null);var v = cljs.core.nth.call(null,vec__13536,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13538 = seq__13532;
var G__13539 = chunk__13533;
var G__13540 = count__13534;
var G__13541 = (i__13535 + 1);
seq__13532 = G__13538;
chunk__13533 = G__13539;
count__13534 = G__13540;
i__13535 = G__13541;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13532);if(temp__4092__auto__)
{var seq__13532__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13532__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13532__$1);{
var G__13542 = cljs.core.chunk_rest.call(null,seq__13532__$1);
var G__13543 = c__4262__auto__;
var G__13544 = cljs.core.count.call(null,c__4262__auto__);
var G__13545 = 0;
seq__13532 = G__13542;
chunk__13533 = G__13543;
count__13534 = G__13544;
i__13535 = G__13545;
continue;
}
} else
{var vec__13537 = cljs.core.first.call(null,seq__13532__$1);var k = cljs.core.nth.call(null,vec__13537,0,null);var v = cljs.core.nth.call(null,vec__13537,1,null);elem.setAttribute(cljs.core.name.call(null,k),(((v instanceof cljs.core.Keyword))?cljs.core.name.call(null,v):v));
{
var G__13546 = cljs.core.next.call(null,seq__13532__$1);
var G__13547 = null;
var G__13548 = 0;
var G__13549 = 0;
seq__13532 = G__13546;
chunk__13533 = G__13547;
count__13534 = G__13548;
i__13535 = G__13549;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.attr = (function attr(elem,things){if(cljs.core.map_QMARK_.call(null,things))
{return lt.util.dom.set_attr.call(null,elem,things);
} else
{return elem.getAttribute(cljs.core.name.call(null,things));
}
});
lt.util.dom.parent = (function parent(elem){return elem.parentNode;
});
lt.util.dom.children = (function children(elem){return elem.children;
});
lt.util.dom.remove = (function remove(elem){var temp__4092__auto__ = lt.util.dom.parent.call(null,elem);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.removeChild(elem);
} else
{return null;
}
});
lt.util.dom.empty = (function empty(elem){return elem.innerHTML = "";
});
/**
* @param {...*} var_args
*/
lt.util.dom.val = (function() { 
var val__delegate = function (elem,p__13550){var vec__13552 = p__13550;var v = cljs.core.nth.call(null,vec__13552,0,null);if(cljs.core.not.call(null,v))
{return elem.value;
} else
{return elem.value = v;
}
};
var val = function (elem,var_args){
var p__13550 = null;if (arguments.length > 1) {
  p__13550 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return val__delegate.call(this,elem,p__13550);};
val.cljs$lang$maxFixedArity = 1;
val.cljs$lang$applyTo = (function (arglist__13553){
var elem = cljs.core.first(arglist__13553);
var p__13550 = cljs.core.rest(arglist__13553);
return val__delegate(elem,p__13550);
});
val.cljs$core$IFn$_invoke$arity$variadic = val__delegate;
return val;
})()
;
lt.util.dom.prevent = (function prevent(e){return e.preventDefault();
});
lt.util.dom.stop_propagation = (function stop_propagation(e){return e.stopPropagation();
});
lt.util.dom.siblings = (function siblings(elem){return lt.util.dom.parent.call(null,elem).children;
});
lt.util.dom.parents = (function parents(elem,sel){var root = lt.util.dom.parent.call(null,lt.util.dom.$.call(null,new cljs.core.Keyword(null,"body","body",1016933652)));var p = lt.util.dom.parent.call(null,elem);while(true){
if(cljs.core.truth_((function (){var and__3508__auto__ = p;if(cljs.core.truth_(and__3508__auto__))
{return cljs.core.not_EQ_.call(null,p,root);
} else
{return and__3508__auto__;
}
})()))
{if(cljs.core.truth_(p.webkitMatchesSelector(cljs.core.name.call(null,sel))))
{return p;
} else
{{
var G__13554 = lt.util.dom.parent.call(null,p);
p = G__13554;
continue;
}
}
} else
{return null;
}
break;
}
});
lt.util.dom.next = (function next(elem){return elem.nextElementSibling;
});
lt.util.dom.before = (function before(elem,neue){return lt.util.dom.parent.call(null,elem).insertBefore(neue,elem);
});
lt.util.dom.after = (function after(elem,neue){var temp__4090__auto__ = lt.util.dom.next.call(null,elem);if(cljs.core.truth_(temp__4090__auto__))
{var n = temp__4090__auto__;return lt.util.dom.before.call(null,n,neue);
} else
{return lt.util.dom.append.call(null,lt.util.dom.parent.call(null,elem),neue);
}
});
lt.util.dom.replace_with = (function replace_with(orig,neue){var temp__4092__auto__ = lt.util.dom.parent.call(null,orig);if(cljs.core.truth_(temp__4092__auto__))
{var p = temp__4092__auto__;return p.replaceChild(neue,orig);
} else
{return null;
}
});
lt.util.dom.height = (function height(elem){return elem.clientHeight;
});
lt.util.dom.width = (function width(elem){return elem.clientWidth;
});
lt.util.dom.scroll_width = (function scroll_width(elem){return elem.scrollWidth;
});
lt.util.dom.offset_top = (function offset_top(elem){return elem.offsetTop;
});
/**
* @param {...*} var_args
*/
lt.util.dom.scroll_top = (function() { 
var scroll_top__delegate = function (elem,p__13555){var vec__13557 = p__13555;var v = cljs.core.nth.call(null,vec__13557,0,null);if(cljs.core.not.call(null,v))
{return elem.scrollTop;
} else
{return elem.scrollTop = v;
}
};
var scroll_top = function (elem,var_args){
var p__13555 = null;if (arguments.length > 1) {
  p__13555 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return scroll_top__delegate.call(this,elem,p__13555);};
scroll_top.cljs$lang$maxFixedArity = 1;
scroll_top.cljs$lang$applyTo = (function (arglist__13558){
var elem = cljs.core.first(arglist__13558);
var p__13555 = cljs.core.rest(arglist__13558);
return scroll_top__delegate(elem,p__13555);
});
scroll_top.cljs$core$IFn$_invoke$arity$variadic = scroll_top__delegate;
return scroll_top;
})()
;
lt.util.dom.top = (function top(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"top","top",1014019271));
});
lt.util.dom.bottom = (function bottom(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"bottom","bottom",3925642653));
});
lt.util.dom.left = (function left(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"left","left",1017222009));
});
lt.util.dom.right = (function right(elem){return lt.util.dom.css.call(null,elem,new cljs.core.Keyword(null,"right","right",1122416014));
});
/**
* @param {...*} var_args
*/
lt.util.dom.html = (function() { 
var html__delegate = function (elem,p__13559){var vec__13561 = p__13559;var h = cljs.core.nth.call(null,vec__13561,0,null);if(cljs.core.not.call(null,h))
{return elem.innerHTML;
} else
{return elem.innerHTML = h;
}
};
var html = function (elem,var_args){
var p__13559 = null;if (arguments.length > 1) {
  p__13559 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 1),0);} 
return html__delegate.call(this,elem,p__13559);};
html.cljs$lang$maxFixedArity = 1;
html.cljs$lang$applyTo = (function (arglist__13562){
var elem = cljs.core.first(arglist__13562);
var p__13559 = cljs.core.rest(arglist__13562);
return html__delegate(elem,p__13559);
});
html.cljs$core$IFn$_invoke$arity$variadic = html__delegate;
return html;
})()
;
lt.util.dom.__GT_ev = (function __GT_ev(ev){return [cljs.core.str(cljs.core.name.call(null,ev))].join('');
});
/**
* @param {...*} var_args
*/
lt.util.dom.trigger = (function() { 
var trigger__delegate = function (elem,ev,p__13563){var vec__13565 = p__13563;var opts = cljs.core.nth.call(null,vec__13565,0,null);var e = document.createEvent("HTMLEvents");e.initEvent(cljs.core.name.call(null,ev),true,true);
e.opts = opts;
return elem.dispatchEvent(e);
};
var trigger = function (elem,ev,var_args){
var p__13563 = null;if (arguments.length > 2) {
  p__13563 = cljs.core.array_seq(Array.prototype.slice.call(arguments, 2),0);} 
return trigger__delegate.call(this,elem,ev,p__13563);};
trigger.cljs$lang$maxFixedArity = 2;
trigger.cljs$lang$applyTo = (function (arglist__13566){
var elem = cljs.core.first(arglist__13566);
arglist__13566 = cljs.core.next(arglist__13566);
var ev = cljs.core.first(arglist__13566);
var p__13563 = cljs.core.rest(arglist__13566);
return trigger__delegate(elem,ev,p__13563);
});
trigger.cljs$core$IFn$_invoke$arity$variadic = trigger__delegate;
return trigger;
})()
;
lt.util.dom.on = (function on(elem,ev,cb){return elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.off = (function off(elem,ev,cb){return elem.removeEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
});
lt.util.dom.on_STAR_ = (function on_STAR_(elem,evs){var seq__13573 = cljs.core.seq.call(null,evs);var chunk__13574 = null;var count__13575 = 0;var i__13576 = 0;while(true){
if((i__13576 < count__13575))
{var vec__13577 = cljs.core._nth.call(null,chunk__13574,i__13576);var ev = cljs.core.nth.call(null,vec__13577,0,null);var cb = cljs.core.nth.call(null,vec__13577,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__13579 = seq__13573;
var G__13580 = chunk__13574;
var G__13581 = count__13575;
var G__13582 = (i__13576 + 1);
seq__13573 = G__13579;
chunk__13574 = G__13580;
count__13575 = G__13581;
i__13576 = G__13582;
continue;
}
} else
{var temp__4092__auto__ = cljs.core.seq.call(null,seq__13573);if(temp__4092__auto__)
{var seq__13573__$1 = temp__4092__auto__;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13573__$1))
{var c__4262__auto__ = cljs.core.chunk_first.call(null,seq__13573__$1);{
var G__13583 = cljs.core.chunk_rest.call(null,seq__13573__$1);
var G__13584 = c__4262__auto__;
var G__13585 = cljs.core.count.call(null,c__4262__auto__);
var G__13586 = 0;
seq__13573 = G__13583;
chunk__13574 = G__13584;
count__13575 = G__13585;
i__13576 = G__13586;
continue;
}
} else
{var vec__13578 = cljs.core.first.call(null,seq__13573__$1);var ev = cljs.core.nth.call(null,vec__13578,0,null);var cb = cljs.core.nth.call(null,vec__13578,1,null);elem.addEventListener(lt.util.dom.__GT_ev.call(null,ev),cb);
{
var G__13587 = cljs.core.next.call(null,seq__13573__$1);
var G__13588 = null;
var G__13589 = 0;
var G__13590 = 0;
seq__13573 = G__13587;
chunk__13574 = G__13588;
count__13575 = G__13589;
i__13576 = G__13590;
continue;
}
}
} else
{return null;
}
}
break;
}
});
lt.util.dom.active_element = (function active_element(){return document.activeElement;
});
lt.util.dom.focus = (function focus(elem){return elem.focus();
});
lt.util.dom.blur = (function blur(elem){return elem.blur();
});
lt.util.dom.selection = (function selection(elem,start,stop,dir){return elem.setSelectionRange(start,stop,dir);
});
lt.util.dom.make = (function make(str){var d = document.createElement("div");lt.util.dom.html.call(null,d,str);
return lt.util.dom.children.call(null,d);
});
lt.util.dom.index = (function index(e){var p = lt.util.dom.parent.call(null,e);var c = (cljs.core.truth_(p)?lt.util.dom.children.call(null,p):[]);var len = c.length;if(cljs.core.not.call(null,p))
{return -1;
} else
{var i = 0;while(true){
if((i >= len))
{return null;
} else
{if(cljs.core._EQ_.call(null,(c[i]),e))
{return i;
} else
{{
var G__13591 = (i + 1);
i = G__13591;
continue;
}
}
}
break;
}
}
});
lt.util.dom.ready = (function ready(func){return lt.util.dom.on.call(null,document,new cljs.core.Keyword(null,"DOMContentLoaded","DOMContentLoaded",3783578446),func);
});
lt.util.dom.fragment = (function fragment(items){var frag = document.createDocumentFragment();var seq__13596_13600 = cljs.core.seq.call(null,items);var chunk__13597_13601 = null;var count__13598_13602 = 0;var i__13599_13603 = 0;while(true){
if((i__13599_13603 < count__13598_13602))
{var i_13604 = cljs.core._nth.call(null,chunk__13597_13601,i__13599_13603);frag.appendChild(i_13604);
{
var G__13605 = seq__13596_13600;
var G__13606 = chunk__13597_13601;
var G__13607 = count__13598_13602;
var G__13608 = (i__13599_13603 + 1);
seq__13596_13600 = G__13605;
chunk__13597_13601 = G__13606;
count__13598_13602 = G__13607;
i__13599_13603 = G__13608;
continue;
}
} else
{var temp__4092__auto___13609 = cljs.core.seq.call(null,seq__13596_13600);if(temp__4092__auto___13609)
{var seq__13596_13610__$1 = temp__4092__auto___13609;if(cljs.core.chunked_seq_QMARK_.call(null,seq__13596_13610__$1))
{var c__4262__auto___13611 = cljs.core.chunk_first.call(null,seq__13596_13610__$1);{
var G__13612 = cljs.core.chunk_rest.call(null,seq__13596_13610__$1);
var G__13613 = c__4262__auto___13611;
var G__13614 = cljs.core.count.call(null,c__4262__auto___13611);
var G__13615 = 0;
seq__13596_13600 = G__13612;
chunk__13597_13601 = G__13613;
count__13598_13602 = G__13614;
i__13599_13603 = G__13615;
continue;
}
} else
{var i_13616 = cljs.core.first.call(null,seq__13596_13610__$1);frag.appendChild(i_13616);
{
var G__13617 = cljs.core.next.call(null,seq__13596_13610__$1);
var G__13618 = null;
var G__13619 = 0;
var G__13620 = 0;
seq__13596_13600 = G__13617;
chunk__13597_13601 = G__13618;
count__13598_13602 = G__13619;
i__13599_13603 = G__13620;
continue;
}
}
} else
{}
}
break;
}
return frag;
});
